%define	with_bzip2		1
%define strip_binaries		1

# XXX legacy requires './' payload prefix to be omitted from rpm packages.
%define	_noPayloadPrefix	1

%define	__prefix	%{?_prefix}%{!?_prefix:/usr}
%{?!_lib: %define _lib lib}
%{expand: %%define __share %(if [ -d %{__prefix}/share/man ]; then echo /share ; else echo %%{nil} ; fi)}

%define	__bindir	%{__prefix}/bin
%define	__includedir	%{__prefix}/include
%define	__libdir	%{__prefix}/%{_lib}
%define	__mandir	%{__prefix}%{__share}/man

Summary:	The Red Hat package management system.
Name:		rpm
Version:	4.4.2
Release:	5
Group:		System Environment/Base
Source0:	ftp://jbj.org/pub/rpm-devel/rpm-%{version}.tar.gz
Source1:	engarde-gnupg-20011023.tar.gz
Patch00:	rpm-4.4.1-posttrans.patch
Patch01:	rpm-4.4.1-gcc4.patch
Patch02:	rpm-4.4.1-hkp-disable.patch
Patch03:	rpm-4.4.1-read-macro.patch
Patch04:	rpm-4.4.1-fileconflicts.patch
Patch05:	rpm-4.4.1-prereq.patch
Patch06:	rpm-4.4.1-nonmerged.patch
Patch07:	rpm-4.4.1-prepostun.patch
Patch08:	rpm-4.4.1-ordererase.patch
Patch09:	rpm-4.4.2-matchpathcon.patch
Patch10:	rpm-4.4.1-check-symlinks.patch
Patch20:	rpm-4.4.1-engardeize-gd-1.diff
Patch21:	rpm-4.4.1-kill-perl-epoch-and-version-fixes-gd-1.diff
Patch22:	rpm-4.4.2-fix-beecrypt-and-neon-includes-gd-1.diff
Patch23:	rpm-4.4.2-no-libdir-symlinks-gd-1.diff
License:	GPL
Prereq:		gawk fileutils textutils mktemp
Requires:	popt = 1.10.1, beecrypt >= 4.1.2, neon, sqlite
BuildRequires:	db4-devel, bzip2 >= 1.0.2, elfutils-libelf, neon-devel
BuildRequires:	zlib-devel, beecrypt-devel >= 4.1.2, sqlite-devel
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root

%description
The RPM Package Manager (RPM) is a powerful command line driven
package management system capable of installing, uninstalling,
verifying, querying, and updating software packages.  Each software
package consists of an archive of files along with information about
the package like its version, a description, etc.

%files -f %{name}.lang
  %defattr(-,root,root)
  %doc RPM-PGP-KEY RPM-GPG-KEY CHANGES GROUPS doc/manual/[a-z]*
  %doc %{_mandir}/man[18]/*.[18]*

  /bin/rpm
  %dir			/etc/rpm
  %config(missingok)	/etc/rpm/macros.db1
  %{__prefix}/bin/gendiff
  %{__prefix}/bin/rpm2cpio
  %{__prefix}/bin/rpmdb
  %{__prefix}/bin/rpm[deikquv]
  %{__prefix}/bin/rpmquery
  %{__prefix}/bin/rpmsign
  %{__prefix}/bin/rpmverify

  %{__prefix}/%{_lib}/librpm-4.4.so
  %{__prefix}/%{_lib}/librpmdb-4.4.so
  %{__prefix}/%{_lib}/librpmio-4.4.so
  %{__prefix}/%{_lib}/librpmbuild-4.4.so

  %{__prefix}/lib/rpm/config.guess
  %{__prefix}/lib/rpm/config.sub
  %{__prefix}/lib/rpm/convertrpmrc.sh
  %{__prefix}/lib/rpm/macros
  %{__prefix}/lib/rpm/mkinstalldirs
  %{__prefix}/lib/rpm/rpm[deikquv]
  %{__prefix}/lib/rpm/rpmpopt*
  %{__prefix}/lib/rpm/rpmrc

%ifarch %{ix86}
  %attr(0750,root,admin)	%{__prefix}/lib/rpm/i[3456]86*
  %attr(0750,root,admin)	%{__prefix}/lib/rpm/athlon-*
%endif
%ifarch x86_64
  %attr(0750,root,admin)	%{__prefix}/lib/rpm/x86_64*
%endif
  %attr(0750,root,admin)	%{__prefix}/lib/rpm/noarch-*

  %dir %attr(755,root,admin)	/usr/lib/rpm/gnupg
  %attr(0444,root,root)		/usr/lib/rpm/gnupg/options
  %attr(0444,root,root)		/usr/lib/rpm/gnupg/pubring.gpg
  %attr(0400,root,root)		/usr/lib/rpm/gnupg/secring.gpg
  %attr(0644,root,root)		/usr/lib/rpm/gnupg/trustdb.gpg

%package devel
Summary:	Development files for applications which will manipulate RPM packages.
Group:		Development/Libraries
Requires:	rpm = %{version}, popt

%description devel
This package contains the RPM C library and header files.  These
development files will simplify the process of writing programs which
manipulate RPM packages and databases. These files are intended to
simplify the process of creating graphical package managers or any
other tools that need an intimate knowledge of RPM packages in order
to function.

%files devel
  %defattr(-,root,root)
  %{__prefix}/bin/rpmgraph

  %{__prefix}/include/rpm

  %{__prefix}/%{_lib}/librpm.a
  %{__prefix}/%{_lib}/librpm.la
  %{__prefix}/%{_lib}/librpm.so
  %{__prefix}/%{_lib}/librpmdb.a
  %{__prefix}/%{_lib}/librpmdb.la
  %{__prefix}/%{_lib}/librpmdb.so
  %{__prefix}/%{_lib}/librpmio.a
  %{__prefix}/%{_lib}/librpmio.la
  %{__prefix}/%{_lib}/librpmio.so
  %{__prefix}/%{_lib}/librpmbuild.a
  %{__prefix}/%{_lib}/librpmbuild.la
  %{__prefix}/%{_lib}/librpmbuild.so

  %{__prefix}/lib/rpm/rpmcache
  %{__prefix}/lib/rpm/rpmdb_archive
  %{__prefix}/lib/rpm/rpmdb_checkpoint
  %{__prefix}/lib/rpm/rpmdb_deadlock
  %{__prefix}/lib/rpm/rpmdb_dump
  %{__prefix}/lib/rpm/rpmdb_load
  %{__prefix}/lib/rpm/rpmdb_loadcvt
  %{__prefix}/lib/rpm/rpmdb_printlog
  %{__prefix}/lib/rpm/rpmdb_recover
  %{__prefix}/lib/rpm/rpmdb_stat
  %{__prefix}/lib/rpm/rpmdb_svc
  %{__prefix}/lib/rpm/rpmdb_upgrade
  %{__prefix}/lib/rpm/rpmdb_verify
  %{__prefix}/lib/rpm/rpmfile

%package build
Summary:	Scripts and executable programs used to build packages.
Group:		Development/Tools
Requires:	rpm = %{version}

%description build
This package contains scripts and executable programs that are used to
build packages using RPM.

%files build
  %defattr(-,root,root)

  %dir %{__prefix}/src/engarde
  %dir %{__prefix}/src/engarde/BUILD
  %dir %{__prefix}/src/engarde/SPECS
  %dir %{__prefix}/src/engarde/SOURCES
  %dir %{__prefix}/src/engarde/SRPMS
  %dir %{__prefix}/src/engarde/RPMS
  %{__prefix}/src/engarde/RPMS/*
  %{__prefix}/bin/rpmbuild
  %{__prefix}/lib/rpm/brp-*
  %{__prefix}/lib/rpm/check-files
  %{__prefix}/lib/rpm/check-prereqs
  %{__prefix}/lib/rpm/config.site
  %{__prefix}/lib/rpm/cross-build
  %{__prefix}/lib/rpm/debugedit
  %{__prefix}/lib/rpm/find-debuginfo.sh
  %{__prefix}/lib/rpm/find-lang.sh
  %{__prefix}/lib/rpm/find-prov.pl
  %{__prefix}/lib/rpm/find-provides
  %{__prefix}/lib/rpm/find-provides.perl
  %{__prefix}/lib/rpm/find-req.pl
  %{__prefix}/lib/rpm/find-requires
  %{__prefix}/lib/rpm/find-requires.perl
  %{__prefix}/lib/rpm/get_magic.pl
  %{__prefix}/lib/rpm/getpo.sh
  %{__prefix}/lib/rpm/http.req
  %{__prefix}/lib/rpm/javadeps
  %{__prefix}/lib/rpm/magic
  %{__prefix}/lib/rpm/magic.mgc
  %{__prefix}/lib/rpm/magic.mime
  %{__prefix}/lib/rpm/magic.mime.mgc
  %{__prefix}/lib/rpm/magic.prov
  %{__prefix}/lib/rpm/magic.req
  %{__prefix}/lib/rpm/perl.prov
  %{__prefix}/lib/rpm/perl.req
  %{__prefix}/lib/rpm/perldeps.pl
  %{__prefix}/lib/rpm/pythondeps.sh
  %{__prefix}/lib/rpm/rpm[bt]
  %{__prefix}/lib/rpm/rpmdeps
  %{__prefix}/lib/rpm/trpm
  %{__prefix}/lib/rpm/u_pkg.sh
  %{__prefix}/lib/rpm/vpkg-provides.sh
  %{__prefix}/lib/rpm/vpkg-provides2.sh

%package -n popt
Summary:	A C library for parsing command line parameters.
Group:		Development/Libraries
Version:	1.10.1

%description -n popt
Popt is a C library for parsing command line parameters.  Popt was
heavily influenced by the getopt() and getopt_long() functions, but it
improves on them by allowing more powerful argument expansion.  Popt
can parse arbitrary argv[] style arrays and automatically set
variables based on command line arguments.  Popt allows command line
arguments to be aliased via configuration files and includes utility
functions for parsing arbitrary strings into argv[] arrays using
shell-like rules.

%files -n popt -f popt.lang
  %defattr(0444,root,root,0555)
  %doc %{_mandir}/man3/popt.3*

  %attr(0555,root,root)		%{__prefix}/%{_lib}/libpopt.so.*
  %attr(0555,root,root)		%{__prefix}/%{_lib}/libpopt.so
  %attr(0444,root,root)		%{__prefix}/%{_lib}/libpopt.a
  %attr(0444,root,root)		%{__prefix}/%{_lib}/libpopt.la
  %attr(0444,root,root)		%{__prefix}/include/popt.h

%prep
%setup -q -b 0 -T 1
%patch00 -p0
%patch01 -p1
%patch02 -p1
%patch03 -p1
%patch04 -p1
%patch05 -p1
%patch06 -p1
%patch07 -p1
%patch08 -p1
%patch09 -p1
%patch10 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1

%build
  export CFLAGS="$RPM_OPT_FLAGS"

# %configure --without-python --with-selinux
  ./configure --prefix=%{__prefix} --sysconfdir=%{_sysconfdir} \
	--localstatedir=%{_var} --infodir='${prefix}%{__share}/info' \
	--mandir='${prefix}%{__share}/man' \
	--enable-posixmutexes --without-javaglue --without-python \
	--with-selinux
  make

%install
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

  make DESTDIR="$RPM_BUILD_ROOT" install

for i in librpm.la librpmbuild.la librpmdb.la librpmio.la ; do
        sed -i -e 's~-L'"$RPM_BUILD_ROOT"'[^ ]* ~~g' \
                -e 's~-L'"$RPM_BUILD_DIR"'[^ ]* ~~g' \
                "$RPM_BUILD_ROOT%{__libdir}/$i"
done

  mkdir -p $RPM_BUILD_ROOT/etc/rpm
  cat << E_O_F > $RPM_BUILD_ROOT/etc/rpm/macros.db1
%%_dbapi		1
E_O_F

%if %{strip_binaries}
  strip $RPM_BUILD_ROOT/bin/rpm
  strip $RPM_BUILD_ROOT/%{__bindir}/rpm2cpio
%endif

  # Install our system-wide keyring.
  pushd $RPM_BUILD_ROOT/usr/lib/rpm
  tar -zxf %{SOURCE1}
  mv engarde-gnupg gnupg
  popd

  # Fix the rpm[euvt] symlinks.
  pushd $RPM_BUILD_ROOT/%{__prefix}/lib/rpm
    ln -sf rpmi rpme
    ln -sf rpmi rpmu
    ln -sf rpmq rpmv
    ln -sf rpmb rpmt
  popd

  # Remove unpackaged files.
  rm -f $RPM_BUILD_ROOT/%{__prefix}/lib/rpm/Specfile.pm
  rm -f $RPM_BUILD_ROOT/%{__prefix}/lib/rpm/cpanflute
  rm -f $RPM_BUILD_ROOT/%{__prefix}/lib/rpm/cpanflute2
  rm -f $RPM_BUILD_ROOT/%{__prefix}/lib/rpm/freshen.sh
  rm -f $RPM_BUILD_ROOT/%{__prefix}/lib/rpm/gnupg/pubring.gpg~
  rm -f $RPM_BUILD_ROOT/%{__prefix}/lib/rpm/pentium3-linux/macros
  rm -f $RPM_BUILD_ROOT/%{__prefix}/lib/rpm/pentium4-linux/macros
  rm -f $RPM_BUILD_ROOT/%{__prefix}/lib/rpm/rpm.daily
  rm -f $RPM_BUILD_ROOT/%{__prefix}/lib/rpm/rpm.log
  rm -f $RPM_BUILD_ROOT/%{__prefix}/lib/rpm/rpm.xinetd
  rm -f $RPM_BUILD_ROOT/%{__prefix}/lib/rpm/rpm2cpio.sh
  rm -f $RPM_BUILD_ROOT/%{__prefix}/lib/rpm/rpmdiff
  rm -f $RPM_BUILD_ROOT/%{__prefix}/lib/rpm/rpmdiff.cgi
  rm -f $RPM_BUILD_ROOT/%{__prefix}/lib/rpm/sql.prov
  rm -f $RPM_BUILD_ROOT/%{__prefix}/lib/rpm/sql.req
  rm -f $RPM_BUILD_ROOT/%{__prefix}/lib/rpm/tcl.req
  rm -f $RPM_BUILD_ROOT/%{__prefix}/lib/rpm/tgpg
  rm -f $RPM_BUILD_ROOT/%{__prefix}/lib/rpmpopt
  rm -f $RPM_BUILD_ROOT/%{__prefix}/lib/rpmrc
  rm -f $RPM_BUILD_ROOT/%{_mandir}/*/man?/*

  %find_lang %{name}
  %find_lang popt

%pre
    if [ -f /var/lib/rpm/Packages -a -f /var/lib/rpm/packages.rpm ]; then
	exit 1
    fi
    exit 0

%post
    /sbin/ldconfig

    if [ -f /var/lib/rpm/packages.rpm ]; then
	: # do nothing
    elif [ -f /var/lib/rpm/Packages ]; then
	# undo db1 configuration
	rm -f /etc/rpm/macros.db1
    else
	# initialize database
	rm -f /etc/rpm/macros.db1
	/bin/rpm --initdb
    fi

%postun -p /sbin/ldconfig

%post devel   -p /sbin/ldconfig
%postun devel -p /sbin/ldconfig

%post -n popt   -p /sbin/ldconfig
%postun -n popt -p /sbin/ldconfig

%clean
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%changelog
* Tue Aug 30 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.4.2, Release 5
  - Rebuild against latest libneon.

* Wed Aug 10 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.4.2, Release 4
  - Fix rpm[euvt] symlinks in /usr/lib/rpm.

* Tue Jul 26 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.4.2, Release 3
  - Make x86_64-friendly.
  - Bring over more of the __ macros from the Red Hat package.
  - Don't create symlinks for rpmrc and friends in libdir.
  - Package pythondeps.sh.

* Fri Jul 08 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.4.2, Release 2
  - Rebuild against openssl-0.9.8.

* Tue Jun 28 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.4.2, Release 1
  - Initial build for EnGarde Secure Linux 3.0.
